module Peerplays
  # See: {https://www.peerplays.tech/api/peerplays-wallet-api Wallet API}
  class WalletApi < Peerplays::Api
    WALLET_API_NAMESPACE = 'wallet'.freeze
    WALLET_API_METHODS = %i(
      list_my_accounts
      list_accounts
      list_account_balances
      register_account
      upgrade_account
      create_account_with_brain_key
      transfer
      transfer2
      whitelist_account
      get_vesting_balances
      withdraw_vesting
      get_account
      get_account_id
      get_account_history
      approve_proposal
      list_my_accounts
      list_accounts
      list_account_balances
      register_account
      upgrade_account
      create_account_with_brain_key
      transfer
      transfer2
      whitelist_account
      get_vesting_balances
      withdraw_vesting
      get_account
      get_account_id
      get_account_history
      approve_proposal
      get_block
      get_account_count
      get_global_properties
      get_dynamic_global_properties
      get_object
      help
      gethelp
      info
      about
      network_get_connected_peers
      create_committee_member
      get_witness
      get_committee_member
      list_witnesses
      list_committee_members
      create_witness
      update_witness
      create_worker
      update_worker_votes
      vote_for_committee_member
      vote_for_witness
      set_voting_proxy
      set_desired_witness_and_committee_member_count
      propose_parameter_change
      propose_fee_change
      set_key_label
      get_key_label
      get_public_key
      get_blind_accounts
      get_my_blind_accounts
      get_blind_balances
      create_blind_account
      transfer_to_blind
      transfer_from_blind
      blind_transfer
      blind_history
      receive_blind_transfer
      sell_asset
      borrow_asset
      cancel_order
      settle_asset
      get_market_history
      get_limit_orders
      get_call_orders
      get_settle_orders
      begin_builder_transaction
      add_operation_to_builder_transaction
      replace_operation_in_builder_transaction
      set_fees_on_builder_transaction
      preview_builder_transaction
      sign_builder_transaction
      propose_builder_transaction
      propose_builder_transaction2
      remove_builder_transaction
      serialize_transaction
      sign_transaction
      get_prototype_operation
      is_new
      is_locked
      lock
      unlock
      set_password
      dump_private_keys
      import_key
      import_accounts
      import_account_keys
      import_balance
      suggest_brain_key
      get_transaction_id
      get_private_key
      load_wallet_file
      normalize_brain_key
      save_wallet_file
    ).freeze
    
    def initialize(options = {})
      @api_name = WALLET_API_NAMESPACE
      @methods = WALLET_API_METHODS
      
      super
    end
  end
end
